'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = asyncDispatch;

var _eventualValues = require('eventual-values');

var _eventualValues2 = _interopRequireDefault(_eventualValues);

var _updeep = require('updeep');

var _updeep2 = _interopRequireDefault(_updeep);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function isNotReadyOrUndefined(value) {
  return value === undefined || !_eventualValues2.default.isReady(value);
}

function makeAction(type, key, path, status, overrideStatus) {
  var payload = arguments.length <= 5 || arguments[5] === undefined ? null : arguments[5];

  var action = {
    type: status === 'pending' ? type : type + '_' + status.toUpperCase()
  };

  switch (status) {
    case 'success':
      action.payload = _defineProperty({}, key, _eventualValues2.default.resolve(payload));
      break;
    case 'error':
      action.payload = _defineProperty({}, key, _eventualValues2.default.reject(payload));

      break;
    default:
      action.payload = _defineProperty({}, key, overrideStatus ? (0, _eventualValues2.default)() : _updeep2.default.ifElse(isNotReadyOrUndefined, _eventualValues2.default, _eventualValues2.default.resolve));

      break;
  }

  if (path !== null) {
    action.path = path;
  }

  return action;
}

function asyncDispatch(dispatch, type, key, promise) {
  var overrideStatus = arguments.length <= 4 || arguments[4] === undefined ? false : arguments[4];
  var path = arguments.length <= 5 || arguments[5] === undefined ? null : arguments[5];

  promise.then(function (data) {
    dispatch(makeAction(type, key, path, 'success', overrideStatus, data));
  }).catch(function (error) {
    dispatch(makeAction(type, key, path, 'error', overrideStatus, error));
  });

  return makeAction(type, key, path, 'pending', overrideStatus);
}