'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = magicAsyncMiddleware;

var _splitAsyncKeys2 = require('./splitAsyncKeys');

var _splitAsyncKeys3 = _interopRequireDefault(_splitAsyncKeys2);

var _asyncDispatch = require('./asyncDispatch');

var _asyncDispatch2 = _interopRequireDefault(_asyncDispatch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function magicAsyncMiddleware(store) {
  return function (next) {
    return function (action) {
      if (action.payload && _typeof(action.payload) === 'object' && action.payload.promise === undefined && action.payload.length === undefined) {
        (function () {
          var _splitAsyncKeys = (0, _splitAsyncKeys3.default)(action.payload);

          var syncDiff = _splitAsyncKeys.syncDiff;
          var asyncDiff = _splitAsyncKeys.asyncDiff;


          if (Object.keys(asyncDiff).length > 0) {
            var asyncAction = Object.keys(asyncDiff).reduce(function (memo, key) {
              var promise = asyncDiff[key];

              var values = (0, _asyncDispatch2.default)(store.dispatch, action.type, key, promise, action.overrideStatus, action.path);

              return _extends({}, memo, {
                payload: _extends({}, memo.payload, values.payload)
              });
            }, {
              type: action.type,
              path: action.path,
              payload: syncDiff
            });

            next(asyncAction);
          } else {
            next(action);
          }
        })();
      } else {
        next(action);
      }
    };
  };
}