'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = splitAsyncKeys;
function splitAsyncKeys(stateDiff) {
  if (typeof stateDiff === 'function') {
    return { syncDiff: stateDiff, asyncDiff: {} };
  }

  var syncDiff = {};
  var asyncDiff = {};

  Object.keys(stateDiff).forEach(function (key) {
    var value = stateDiff[key];

    if (value !== null && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && typeof value.then === 'function') {
      asyncDiff[key] = value;
    } else {
      syncDiff[key] = value;
    }
  });

  return { syncDiff: syncDiff, asyncDiff: asyncDiff };
}